
#load "/usr/lib/ocaml/nums.cma";;
#load "pSet.cmo";;
#load "pMap.cmo";;
#load "term.cmo";;
#load "predicate.cmo";;
#load "interp.cmo";;    

open PSet.Set
open Term
open Predicate
open Interp
;;

(* so we can print out formulas readably *)

#install_printer print_funterm;;
#install_printer print_term;;

let bar = var "bar"
let baz = var "baz"
let foo = var "foo"


let p1 = pEquality (bar,baz)
let p2 = pNot (pEquality (foo,baz))
let p3 = pEquality (foo,bar)

let a = of_list [p1;p2] (* set containing p1 and p2 *)
let b = of_list [p3]

let pf = EqNeq (Trans (Hyp(p3),Hyp(p1))) (* prove a contradiction *)
;;
interpolate (a,b) pf
;;

let a = var "a"
let b = var "b"
let c = var "c"
let d = var "d"
let e = var "e"
let f = var "f"

let p1 = pEquality (a,b)
let p2 = pEquality (e,f)
let p3 = pNot(pEquality (e,a))

let p4 = pEquality (b,c)
let p5 = pEquality (c,d)
let p6 = pEquality (d,e)

let pf = EqNeq(Symm(Trans(Hyp(p1),Trans(Hyp(p4),Trans(Hyp(p5),Hyp(p6))))))
;;


interpolate (of_list[p1;p2;p3], of_list[p4;p5;p6]) pf
;;

let p1 = pEquality(a,b)

let p2 = pNot(pEquality(apply("f",[a]),apply("f",[b])))

let pf = EqNeq(Cong("f",[Hyp(p1)]))
;;

interpolate (of_list[p1], of_list[p2]) pf
;;

interpolate (of_list[p1;p2], of_list[p5]) pf
;;

interpolate (of_list[p2], of_list[p1]) pf
;;

interpolate (of_list[p5], of_list[p1;p2]) pf
;;

let p5 = pEquality (c,d)
let p6 = pNot(pEquality(apply("f",[a;c]),apply("f",[b;d])))

let p1 = pEquality(a,b)
;;

let pf = EqNeq(Cong("f",[Hyp(p1);Hyp(p5)]))
;;

interpolate (of_list[p5;p6], of_list[p1]) pf
;;

interpolate (of_list[p1], of_list[p5;p6]) pf
;;

interpolate (of_list[p6], of_list[p1;p5]) pf
;;

let p1 = pLeq(a,b)
let p2 = pLeq(b,a)

let p3 = pNot(pEquality(a,b))

let pf = EqNeq(EqLeq(a,b,Hyp(p2),Hyp(p1)))
;;

interpolate (of_list[p1;p2], of_list[p3]) pf
;;
interpolate (of_list[p3], of_list[p1;p2]) pf
;;

open Num
;;

let p1 = pEquality(a,b)
let p2 = pEquality(c,d)

let p3 = pNot(pEquality(add_term a c, add_term b d))

let pf1 = Comb((num_of_int 1),LeqEq(Hyp(p1)),(num_of_int 1),LeqEq(Hyp(p2))) (* prove a+c <= b+d *)
let pf2 = Comb((num_of_int 1),LeqEq(Symm(Hyp(p1))),(num_of_int 1),LeqEq(Symm(Hyp(p2)))) (* prove a+c >= b+d *)
let pf = EqNeq(EqLeq(add_term a c, add_term b d, pf2, pf1))
;;

interpolate (of_list[p1;p2], of_list[p3]) pf
;;
interpolate (of_list[p1;p3], of_list[p2]) pf
;;
